import { Observable } from "rxjs";
import { DocumentNode, OperationTypeNode } from "graphql/language";
import { StreamRequester } from "../../public-api";
import { Payload } from "@rsocket/core";
export type GraphqlSubscribe<T> = {
    result: Observable<T>;
    requester: StreamRequester;
};
interface DocumentNodeWithExtractor<T, U = any> {
    documentNode: DocumentNode;
    variables?: U;
    extract: (payload: Payload) => T;
}
export interface QueryDocumentNode<T, U = any> extends DocumentNodeWithExtractor<T, U> {
    __typename: OperationTypeNode.QUERY;
}
export interface SubscriptionDocumentNode<T, U = any> extends DocumentNodeWithExtractor<T, U> {
    __typename: OperationTypeNode.SUBSCRIPTION;
}
export interface MutationDocumentNode<T, U = any> extends DocumentNodeWithExtractor<T, U> {
    __typename: OperationTypeNode.MUTATION;
}
export {};
