import { ReplaySubject } from "rxjs";
import { ConnectorConfig, Payload } from "@rsocket/core";
import { ChannelParam, ConnectionStatus, FireAndForgotParam, RawPayload, ResponseParam, RsocketServer, StreamParam } from "./rsocket.type";
export declare class RSocketClient {
    private rSocket;
    connectionStatus: ReplaySubject<ConnectionStatus>;
    error: ReplaySubject<Error>;
    serverName: string;
    private inRacing;
    constructor(config: Omit<ConnectorConfig, 'transport' | 'resume'>, rsocketServer: RsocketServer, waitFirstFrame: boolean, resolve: (value: RSocketClient) => void, reject: (reason?: any) => void, abortSignal: AbortSignal);
    encodePayload({ route, data, encodeData }: RawPayload): Payload;
    fireAndForget<T>({ payload }: FireAndForgotParam<T>): void;
    requestResponse({ payload, responderStream }: ResponseParam): import("rxjs").Observable<import("@rsocket/core").Cancellable & import("@rsocket/core").OnExtensionSubscriber>;
    requestStream({ payload, initialRequestN, responderStream }: StreamParam): import("rxjs").Observable<import("@rsocket/core").Requestable & import("@rsocket/core").Cancellable & import("@rsocket/core").OnExtensionSubscriber>;
    requestChannel<T>({ payload, initialRequestN, isCompleted, responderStream }: ChannelParam<T>): import("rxjs").Observable<import("@rsocket/core").OnTerminalSubscriber & import("@rsocket/core").OnNextSubscriber & import("@rsocket/core").OnExtensionSubscriber & import("@rsocket/core").Requestable & import("@rsocket/core").Cancellable>;
}
