import { RSocketClient } from "./rsocket-client";
import { RsocketConfig } from "./rsocket-config";
import { Auth, ChannelParam, ConnectionStatus, FireAndForgotParam, ResponseParam, RsocketServerLatency, StreamParam } from "./rsocket.type";
import { ReplaySubject } from "rxjs";
import { RequestType, Responder } from "./rsocket-responder";
import * as i0 from "@angular/core";
export declare class RsocketService {
    rsocketClient: ReplaySubject<RSocketClient>;
    connectionStatus: import("@angular/core").Signal<ConnectionStatus>;
    error: import("@angular/core").Signal<Error | undefined>;
    serverLatency: import("@angular/core").WritableSignal<RsocketServerLatency>;
    private rsocketConfig;
    private abortController;
    private signal;
    private rSocketResponder;
    connect(waitFirstFrame?: boolean): void;
    fireAndForget<T>(payload: FireAndForgotParam<T>): void;
    requestResponse(param: ResponseParam): import("rxjs").Observable<import("@rsocket/core").Cancellable & import("@rsocket/core").OnExtensionSubscriber>;
    requestStream(param: StreamParam): import("rxjs").Observable<import("@rsocket/core").Requestable & import("@rsocket/core").Cancellable & import("@rsocket/core").OnExtensionSubscriber>;
    requestChannel<T>(param: ChannelParam<T>): import("rxjs").Observable<import("@rsocket/core").OnTerminalSubscriber & import("@rsocket/core").OnNextSubscriber & import("@rsocket/core").OnExtensionSubscriber & import("@rsocket/core").Requestable & import("@rsocket/core").Cancellable>;
    setConfig(config: RsocketConfig): void;
    setAuth(auth: Auth): void;
    responder: {
        fireAndForget: <I>(route: string, handler: Responder<I>[RequestType.REQUEST_FNF]) => void;
        requestResponse: <I, O>(route: string, handler: Responder<I, O>[RequestType.REQUEST_RESPONSE]) => void;
    };
    static ɵfac: i0.ɵɵFactoryDeclaration<RsocketService, never>;
    static ɵprov: i0.ɵɵInjectableDeclaration<RsocketService>;
}
